unit ConnectionModule;

interface

uses
  Aurelius.Drivers.Interfaces,
  Aurelius.Drivers.FireDac,  
  FireDAC.Dapt,
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait,
  Aurelius.Sql.MSSQL, Aurelius.Schema.MSSQL, Aurelius.Comp.Connection, Data.DB,
  FireDAC.Comp.Client, Sparkle.HttpServer.Module, Sparkle.HttpServer.Context,
  Sparkle.Module.Static, Sparkle.Comp.Server, Sparkle.Comp.CorsMiddleware,
  Sparkle.Comp.StaticServer, Sparkle.Comp.HttpSysDispatcher;

type
  TFireDacMSSQLConnection = class(TDataModule)
    Connection: TFDConnection;
    AureliusConnection1: TAureliusConnection;
  private
  public
    class function CreateConnection: IDBConnection;
    class function CreateFactory: IDBConnectionFactory;
     
    class function CreatePool(APoolSize: Integer): IDBConnectionPool;
  end;

var
  FireDacMSSQLConnection: TFireDacMSSQLConnection;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses  
  XData.Aurelius.ConnectionPool,
  Aurelius.Drivers.Base;

{$R *.dfm}

{ TMyConnectionModule }

class function TFireDacMSSQLConnection.CreateConnection: IDBConnection;
begin 
  Result := FireDacMSSQLConnection.AureliusConnection1.CreateConnection; 
end;

class function TFireDacMSSQLConnection.CreateFactory: IDBConnectionFactory;
begin
  Result := TDBConnectionFactory.Create(
    function: IDBConnection
    begin
      Result := CreateConnection;
    end
  );
end;

class function TFireDacMSSQLConnection.CreatePool(APoolSize: Integer): IDBConnectionPool;
begin
  Result := TDBConnectionPool.Create(APoolSize, CreateFactory);
end;

end.
